package;

import flixel.FlxG;
import flixel.FlxSprite;
import flixel.system.FlxSound;
import flixel.tweens.FlxEase;
import flixel.tweens.FlxTween;
import flixel.util.FlxAngle;
import flixel.util.FlxColor;


class Boost extends FlxSprite
{
	public var speed:Float = 200;
	private var _sndB:FlxSound;
		
	public function new(X:Float = 0, Y:Float = 0)
	{
		super(X, Y);
		loadGraphic(AssetPaths.Totem2__png, true, 16, 16);
		animation.add("1", [0, 1, 2, 3], 12, true);
		drag.x = drag.y = 1600;
		animation.play("1");
		_sndB = FlxG.sound.load(AssetPaths.bonus__wav);
	}
	
	private function movement():Void
	{
		var _left:Bool = true;
		var mA:Float = 0;
		
		if (_left)
			mA = 180;
		
		FlxAngle.rotatePoint(speed, 0, 0, 0, mA, velocity);
			
	}
	
	override public function update():Void
	{
		movement();
		super.update();
	}
	
	override public function kill():Void
	{
		alive = false;
		FlxTween.tween(this, { alpha:0, y:y + 14 }, .33, { ease:FlxEase.circOut, complete:finishKill } );
		_sndB.play();
	}

	private function finishKill(_):Void
	{
		exists = false;
	}
	
}