package;

import flixel.FlxSprite;
import flixel.tweens.FlxEase;
import flixel.tweens.FlxTween;
import flixel.util.FlxAngle;
import flixel.util.FlxColor;
import flixel.util.FlxRandom;


class Deco extends FlxSprite
{
	public var speed:Float = 40;
		
	public function new(X:Float=0, Y:Float=0) 
	{
		var bet:Int = (FlxRandom.intRanged(0, 4));
		if (bet == 0)
		{
			super(X - 8, Y + 8);
			loadGraphic(AssetPaths.cabezasola__png, true, 36, 35);
		}
		if (bet == 1)
		{
			super(X, Y + 8);
			loadGraphic(AssetPaths.ventanalarga__png, true, 16, 48);
		}
		if (bet == 2)
		{
			super(X - 4, Y + 12);
			loadGraphic(AssetPaths.torchtransp__png, true, 16, 32);
			animation.add("a", [0, 1, 2, 3, 4, 0, 0, 0, 0], 9, true);
			animation.play("a");
		}
		else
		{
			super(X, Y + 16);
			loadGraphic(AssetPaths.ventanachica__png, true, 16, 32);
		}
		set_immovable;
		drag.x = drag.y = 1600;		
	}
	
	private function movement():Void
	{
		var _left:Bool = true;
		var mA:Float = 0;
		
		if (_left)
			mA = 180;
		
		FlxAngle.rotatePoint(speed, 0, 0, 0, mA, velocity);
	}
	
	override public function update():Void
	{
		movement();
		super.update();
	}
	
	override public function kill():Void
	{
		alive = false;
		FlxTween.tween(this, { alpha:0, y:y + 4 }, .33, { ease:FlxEase.circOut, complete:finishKill } );
	}

	private function finishKill(_):Void
	{
		exists = false;
	}

	
}