package;

import flixel.FlxSprite;
import flixel.tweens.FlxEase;
import flixel.tweens.FlxTween;
import flixel.util.FlxAngle;
import flixel.util.FlxColor;


class Holes extends FlxSprite
{
	public var speed:Float = 200;
		
	public function new(X:Float=0, Y:Float=0,Z:Int=0) 
	{
		super(X, Y);
		loadGraphic("assets/images/floor" + Std.string(Z) + ".png", true, 16, 16);
		set_immovable;
		drag.x = drag.y = 1600;		
	}
	
	private function movement():Void
	{
		var _left:Bool = true;
		var mA:Float = 0;
		
		if (_left)
			mA = 180;
		
		FlxAngle.rotatePoint(speed, 0, 0, 0, mA, velocity);
			
	}
	
	override public function update():Void
	{
		movement();
		super.update();
	}
	
	override public function kill():Void
	{
		alive = false;
		FlxTween.tween(this, { alpha:0, y:y }, .33, { ease:FlxEase.circOut, complete:finishKill } );
	}

	private function finishKill(_):Void
	{
		exists = false;
	}
}