package;

import flixel.FlxG;
import flixel.FlxSprite;
import flixel.FlxState;
import flixel.text.FlxText;
import flixel.ui.FlxButton;
import flixel.util.FlxMath;
import flixel.util.FlxDestroyUtil;
using flixel.util.FlxSpriteUtil;
/**
 * A FlxState which can be used for the game's menu.
 */
class MenuState extends FlxState
{
	private var _btnPlay:FlxButton;
	private var _logo:FlxSprite;
		
	override public function create():Void
	{
		_btnPlay = new FlxButton(0, 0, "Play", launcher);
		_btnPlay.screenCenter();
		add(_btnPlay);
		super.create();
	
		_logo = new FlxSprite(0, 0, AssetPaths.Caratula2__png);
		add(_logo);
		
	}
	
	override public function update():Void
	{
		if (FlxG.keys.anyJustPressed(["SPACE", "W", "Z", "CONTROL", "E", "X"]))
		{
			launcher();
		}
		super.update();
	}
	
	private function launcher():Void
	{
		FlxG.switchState(new PlayState());
	}
	
	override public function destroy():Void
	{
		super.destroy();
		_btnPlay = FlxDestroyUtil.destroy(_btnPlay);
	}

}