package;

import flixel.addons.editors.ogmo.FlxOgmoLoader;
import flixel.addons.editors.tiled.TiledLayer;
import flixel.addons.editors.tiled.TiledMap;
import flixel.addons.editors.tiled.TiledObject;
import flixel.FlxCamera;
import flixel.FlxG;
import flixel.FlxObject;
import flixel.FlxSprite;
import flixel.FlxState;
import flixel.group.FlxTypedGroup;
import flixel.text.FlxText;
import flixel.tile.FlxTilemap;
import flixel.ui.FlxButton;
import flixel.util.FlxMath;
import flixel.util.FlxRandom;


class PlayState extends FlxState
{
	private var _a:Int = 0;
	private var _score:Int = 0;
	private var _player:Player;
	private var _assa:Left;
	private var _back:FlxSprite;
	private var _obstB:FlxTypedGroup<Course>;
	private var _obstR:FlxTypedGroup<Course>;
	private var _difi:FlxTypedGroup<Limiter>;
	private var _death:FlxTypedGroup<Spikes>;
	private var _goal:FlxTypedGroup<Limiter>;
	private var _decos:FlxTypedGroup<Deco>;
	private var _last:FlxTypedGroup<Holes>;
	private var _last2:FlxTypedGroup<Holes>;
	private var _root:Suelo;
	private var _earth:FlxTypedGroup<Limiter>;
	private var _boost:FlxTypedGroup<Boost>;
	private var _map:FlxOgmoLoader;
	private var _mWalls:FlxTilemap;
	private var _hud:HUD;
	
	override public function create():Void
	{
		_map = new FlxOgmoLoader(AssetPaths.test02__oel);
		_mWalls = _map.loadTilemap(AssetPaths.tiles__png, 16, 16, "walls");
		_mWalls.setTileProperties(1, FlxObject.NONE);
		_mWalls.setTileProperties(2, FlxObject.ANY);
		add(_mWalls);
		_back = new FlxSprite(0, 0, AssetPaths.fondo__png);
		add(_back);
		_goal = new FlxTypedGroup<Limiter>();
		add(_goal);
		_root = new Suelo(0, 179);
		add(_root);
		_decos = new FlxTypedGroup<Deco>();
		add(_decos);
		_earth = new FlxTypedGroup<Limiter>();
		add(_earth);
		_obstB = new FlxTypedGroup<Course>();
		add(_obstB);
		_obstR = new FlxTypedGroup<Course>();
		add(_obstR);
		_difi = new FlxTypedGroup<Limiter>();
		add(_difi);
		_death = new FlxTypedGroup<Spikes>();
		add(_death);
		_assa = new Left( -1, 145);
		add(_assa);
		_boost = new FlxTypedGroup<Boost>();
		add(_boost);
		_player = new Player();
		FlxG.camera.follow(_player, FlxCamera.STYLE_TOPDOWN, 1);
		_map.loadEntities(placeEntities, "entities");
		add(_player);
		_last = new FlxTypedGroup<Holes>();
		add(_last);
		_last2 = new FlxTypedGroup<Holes>();
		add(_last2);
		_hud = new HUD();
		add(_hud);
		super.create();
	}
	
	private function placeEntities(entityName:String,entityData:Xml):Void
	{
		var x:Int = Std.parseInt(entityData.get("x"));
		var y:Int = Std.parseInt(entityData.get("y"));
		if (entityName == "player")
		{
			_player.x = x;
			_player.y = y - 15;
		}
		if (entityName == "obstacles")
		{
			_difi.add(new Limiter(x, y));
		}
		if (entityName == "limiter")
		{
			_goal.add(new Limiter(x, y));
			
		}
		if (entityName == "ground")
		{
			_earth.add(new Limiter(x, y - 1));
		}
	}
	
	override public function destroy():Void
	{
		super.destroy();
	}
	
	public function progression():Void //crear obstaculos
	{
		if (_a == 20)
		{
			if (FlxRandom.chanceRoll(25)) //decos
				{
				_decos.add(new Deco((FlxG.width - 32), (32 + (FlxRandom.intRanged(2, 5) * 4))));
				}
		}
		if (_a == 15)
		{
			if (FlxRandom.chanceRoll(45)) //rojos
			{
				var alt:Int = (FlxRandom.intRanged(2, 5) * 32);
				_obstR.add(new Course((FlxG.width - 16), alt, 1));
				_score ++;
				_hud.updateHUD(_score);
			}
		}
		if (_a == 16) //piso
		{
				_last.add(new Holes((FlxG.width - 70), 179, 0));
				_last.add(new Holes((FlxG.width - 54), 179, 0));
				_last.add(new Holes((FlxG.width - 48), 179, 0));
				_last.add(new Holes((FlxG.width - 32), 179, 0));
				_last.add(new Holes((FlxG.width - 16), 179, 1));
				_death.add(new Spikes((FlxG.width), 185));
				_last.add(new Holes((FlxG.width + 16), 179, 2));
				_last.add(new Holes((FlxG.width + 32), 179, 0));
				_last.add(new Holes((FlxG.width + 48), 179, 0));
				_score ++;
				_hud.updateHUD(_score);
		}
		
		if (_a == 25)
		{
			if (FlxRandom.chanceRoll(45)) //spikes
			{
			_death.add(new Spikes((FlxG.width - 16), 162));
			_death.add(new Spikes((FlxG.width), 162));
			}
			else
			{
				_last2.add(new Holes((FlxG.width - 32), 179, 0));
				_last2.add(new Holes((FlxG.width - 16), 179, 0));
				_last2.add(new Holes((FlxG.width), 179, 0));
				_last2.add(new Holes((FlxG.width + 16), 179, 0));
				_last2.add(new Holes((FlxG.width + 32), 179, 0));
				_score ++;
				_hud.updateHUD(_score);
			}
		}	
		if (_a == 30)
		{
			if (FlxRandom.chanceRoll(65)) //jacks
			{
			_boost.add(new Boost((FlxG.width - 16), (FlxRandom.intRanged(1, 2) * 75)));
			_score ++;
			_hud.updateHUD(_score);
			}
			else
			{
				_last2.add(new Holes((FlxG.width - 48), 179, 0));
				_last2.add(new Holes((FlxG.width - 32), 179, 0));
				_last2.add(new Holes((FlxG.width - 16), 179, 0));
				_last2.add(new Holes((FlxG.width), 179, 0));
				_last2.add(new Holes((FlxG.width + 16), 179, 0));
				_last2.add(new Holes((FlxG.width + 32), 179, 0));
				_last2.add(new Holes((FlxG.width + 48), 179, 0));
				_score ++;
				_hud.updateHUD(_score);
			}
		}
		if (_a == 32) //piso
		{
				_last2.add(new Holes((FlxG.width - 48), 179, 0));
				_last2.add(new Holes((FlxG.width - 32), 179, 0));
				_last2.add(new Holes((FlxG.width - 16), 179, 0));
				_last2.add(new Holes((FlxG.width), 179, 0));
				_last2.add(new Holes((FlxG.width + 16), 179, 0));
				_last2.add(new Holes((FlxG.width + 32), 179, 0));
				_last2.add(new Holes((FlxG.width + 48), 179, 0));
				_score ++;
				_hud.updateHUD(_score);
		}
		if (_a == 40)
		{
			if (FlxRandom.chanceRoll(85)) //blues
			{
				var alt:Int = (FlxRandom.intRanged(2, 5) * 32);
				_obstB.add(new Course((FlxG.width - 16), alt, 2));
				_score ++;
				_hud.updateHUD(_score);
				_score ++;
			_hud.updateHUD(_score);
			}
			else
			{
				_last2.add(new Holes((FlxG.width - 48), 179, 0));
				_last2.add(new Holes((FlxG.width - 32), 179, 0));
				_last2.add(new Holes((FlxG.width - 16), 179, 0));
				_last2.add(new Holes((FlxG.width), 179, 0));
				_last2.add(new Holes((FlxG.width + 16), 179, 0));
				_last2.add(new Holes((FlxG.width + 32), 179, 0));
				_last2.add(new Holes((FlxG.width + 48), 179, 0));
				_score ++;
				_hud.updateHUD(_score);
			}
			_a = 0;
			
		}
		if (_a == 48) //piso
		{
				_last2.add(new Holes((FlxG.width - 48), 179, 0));
				_last2.add(new Holes((FlxG.width - 32), 179, 0));
				_last2.add(new Holes((FlxG.width - 16), 179, 0));
				_last2.add(new Holes((FlxG.width), 179, 0));
				_last2.add(new Holes((FlxG.width + 16), 179, 0));
				_last2.add(new Holes((FlxG.width + 32), 179, 0));
				_last2.add(new Holes((FlxG.width + 48), 179, 0));
				_score ++;
				_hud.updateHUD(_score);
		}
		_a ++;
		
	}
	
	override public function update():Void
	{
		super.update();
		progression();
		FlxG.collide(_player, _mWalls);
		FlxG.collide(_player, _death, gameGone2);
		FlxG.collide(_player, _difi, levUp);
		FlxG.overlap(_obstB, _goal, obstacleGone);
		FlxG.overlap(_obstR, _goal, obstacleGone);
		FlxG.overlap(_last, _goal, floorGone);
		FlxG.overlap(_last2, _goal, floorGone);
		FlxG.collide(_last2, _last);
		FlxG.overlap(_player, _goal, gameGone);
		FlxG.overlap(_player, _earth, jumpable);
		FlxG.overlap(_player, _boost, alright);
		mechanicMain();
	}
	
	public function mechanicMain():Void
	{
		if (_player._blank)
		{
			FlxG.collide(_player, _obstB, jumpable2);
			FlxG.collide(_player, _obstR, jumpable2);
			_player._blue = false;
		}
		else if (_player._blue)
		{
			FlxG.overlap(_player, _obstB, pointsUp);
			FlxG.collide(_player, _obstR, jumpable2);
		}
		else
		{
			FlxG.overlap(_player, _obstR, pointsUp);
			FlxG.collide(_player, _obstB, jumpable2);
		}
	}
	
	public function obstacleGone(B:Course, T:Limiter):Void
	{
		if (B.alive && B.exists)
		{
			B.kill();
			_score ++;
			_hud.updateHUD(_score);
		}
	}
	public function lastGone(B:Holes, T:Holes):Void
	{
		if (B.alive && B.exists)
		{
			B.kill();
			_score ++;
			_hud.updateHUD(_score);
		}
	}
	public function floorGone(B:Holes, T:Limiter):Void
	{
		if (B.alive && B.exists)
		{
			B.kill();
			_score ++;
			_hud.updateHUD(_score);
		}
	}
	public function pointsUp(B:Player, T:Course):Void
	{
		if (B.alive && B.exists && T.alive && T.exists)
		{
			_score ++;
			_hud.updateHUD(_score);
		}
	}
	public function alright(B:Player, T:Boost):Void
	{
		_score +100;
		_hud.updateHUD(_score);
		if (B.alive && B.exists && T.alive && T.exists)
		{
			_score +100;
			_hud.updateHUD(_score);
			T.kill();
			B.buenus();
		}
	}
	public function jumpable(B:Player, T:Limiter):Void
	{
		if (B.alive && B.exists)
		{
			B.grounded();
		}
	}
	public function jumpable2(B:Player, T:Course):Void
	{
		if (B.alive && B.exists)
		{
			if(B._airborne)
				B.grounded();
			else
				B.pushed();
		}
	}
	
	public function gameGone(B:Player, T:Limiter):Void
	{
		if (B.alive && B.exists)
		{
			B.kill();
			_score ++;
			ending(1);
		}
	}
	public function gameGone2(B:Player, T:Spikes):Void
	{
		if (B.alive && B.exists)
		{
			B.kill();
			_score ++;
			ending(0);
		}
	}
	public function levUp(B:Player, T:Limiter):Void
	{
		_score +1000;
		_hud.updateHUD(_score);
		if (B.alive && B.exists)
		{
			
		}
	}
	
	private function ending(E:Int=0):Void
	{
		FlxG.switchState(new EndState(_score, E));
	}
	
}