package;

import flixel.FlxSprite;
import flixel.system.FlxSound;
import flixel.tweens.FlxEase;
import flixel.tweens.FlxTween;
import flixel.util.FlxAngle;
import flixel.util.FlxColor;
import flixel.FlxG;
import flixel.util.FlxRandom;

class Player extends FlxSprite
{
	public var speed:Float = 260;
	public var _blue:Bool = true;
	public var _blank:Bool = false;
	public var _countdown:Int = 0;
	public var _boost:Bool = false;
	public var _airborne:Bool = false;
	public var mA:Float = 90;
	public var _rite = false;
	private var _sndT:FlxSound;
	
	public function new(X:Float=0, Y:Float=0) 
	{
		super(X, Y);
		loadGraphic(AssetPaths.indio__png, true, 16, 32);
		animation.add("rb", [9, 14, 15, 16, 2], 15, false);
		animation.add("wb", [0, 1, 2, 3, 4, 5, 6], 10, true);
		animation.add("wr", [7, 8, 9, 10, 11, 12, 13], 10, true);
		animation.add("br", [2, 17, 18, 19, 9], 15, false);
		animation.add("hb", [22, 23, 24, 24], 10, false);
		animation.add("hr", [25, 26, 27, 27], 10, false);
		animation.add("jb", [20], 6, false);
		animation.add("jr", [21], 8, false);
		animation.add("jw", [35], 10, false);
		animation.add("ww", [28, 29, 30, 31, 32, 33, 34], 10, true);
		animation.add("hw", [36, 37, 38, 38], 10, false);
		drag.x = drag.y = 1600;
		setSize(8, 26);
		offset.set(4, 3);
		animation.play("wb");
		_sndT = FlxG.sound.load(AssetPaths.transf__wav);
	}
	
	override public function update():Void
	{
		if (_countdown <= 0)
		{
			movement();
		}
		ritual();
		super.update();
		_countdown --;
	}
	
	public function ritual():Void
	{
		
		_rite = FlxG.keys.anyJustPressed(["CONTROL", "E", "X"]);
		
		if (_rite)
		{
			_sndT.play();
			if (_blue)
			{
				animation.play("br");
				_blue = false;
				_blank = false;
			}
			else
			{
				animation.play("rb");
				_blue = true;
				_blank = false;
			}
		}
		_rite = false;
		
	}
	
	private function movement():Void 
	{
		var _jump:Bool = false;
		var _fall:Bool = false;
		
		_jump = FlxG.keys.anyJustPressed(["SPACE", "W", "Z"]);
		if (_airborne)
			_jump = false;
		
		if (_jump)
		{
			mA = -90;
			FlxAngle.rotatePoint((speed * 1.5), 0, 0, 0, mA, velocity);
			_countdown = 10;
			_airborne = true;
			if (_blank)
				animation.play("jw");
			else if (_blue)
				animation.play("jb");
			else
				animation.play("jr");
		}
		else if (_boost)
		{
			mA = 0;
			FlxAngle.rotatePoint((speed * 1.5), 0, 0, 0, mA, velocity);
			_countdown = 10;
		}
		else
		{
			mA = 90;
			FlxAngle.rotatePoint((speed * 0.85), 0, 0, 0, mA, velocity);
		}
	}
	
	public function buenus():Void
	{
		mA = 0;
		FlxAngle.rotatePoint(speed, 0, 0, 0, mA, velocity);
		_countdown = 5;
		if (FlxRandom.chanceRoll(75))
		{
			_blank = true;
			_blue = false;
			animation.play("ww");
		}
		else if (FlxRandom.chanceRoll(45))
		{
			if (_blue)
			{
				animation.play("br");
				_blue = false;
				_blank = false;
			}
			else
			{
				animation.play("rb");
				_blue = true;
				_blank = false;
			}
		}
					
	}
	public function grounded():Void
	{
		if (_countdown < 1)
		{
			_airborne = false;
		}
		
		if (animation.finished)
		{
			if (_blank)
				animation.play("ww");
			else if (_blue)
				animation.play("wb");
			else
				animation.play("wr");
		}		
	}
	public function pushed():Void
	{
		if (_blank)
			animation.play("hw");
		else if (_blue)
			animation.play("hb");
		else
			animation.play("hr");
	}
	
	override public function kill():Void
	{
		alive = false;
		FlxTween.tween(this, { alpha:0, y:y + 4 }, .33, { ease:FlxEase.circOut, complete:finishKill } );
		//exists = false;
	}

	private function finishKill(_):Void
	{
		exists = false;
	}
	
}